> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Extract Email Attachment

> Extract attachments from an email

## `POST /v1/email/extract-attachments`

<Note>For converting email to PDF please see [PDF from Email](/api-reference/pdf-from-email).</Note>

## Attributes

<Note>Attributes are case-sensitive and should be inside JSON for POST request. for example: `{ "url": "https://example.com/file1.pdf" }`</Note>

| Attribute                     | Type    | Required | Default | Description                                                                                                                                                                                                                                      |
| ----------------------------- | ------- | -------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `url`                         | string  | *Yes*    | -       | URL to the source file [`url` attribute](/api-reference/url-input-and-request-limits#supported-file-sources)                                                                                                                                     |
| `callback`                    | string  | *No*     | -       | The callback URL (or Webhook) used to receive the POST data. see [Webhooks & Callbacks](/api-reference/webhooks). This is only applicable when `async` is set to `true`.                                                                         |
| `inline`                      | boolean | *No*     | `false` | Set to true to return results inside the response. Otherwise, the endpoint will return a URL to the output file generated.                                                                                                                       |
| `async`                       | boolean | *No*     | `false` | Set `async` to `true` for long processes to run in the background, API will then return a `jobId` which you can use with the [Background Job Check endpoint](/api-reference/job-check). Also see [Webhooks & Callbacks](/api-reference/webhooks) |
| `profiles`                    | object  | *No*     | -       | See [Profiles](/api-reference/profiles) for more information.                                                                                                                                                                                    |
|     `outputDataFormat`        | string  | *No*     | -       | If you require your output as `base64` format, set this to `base64`                                                                                                                                                                              |
|     `DataEncryptionAlgorithm` | string  | *No*     | -       | Controls the encryption algorithm used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                        |
|     `DataEncryptionKey`       | string  | *No*     | -       | Controls the encryption key used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                          |
|     `DataEncryptionIV`        | string  | *No*     | -       | Controls the encryption IV used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                           |
|     `DataDecryptionAlgorithm` | string  | *No*     | -       | Controls the decryption algorithm used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                        |
|     `DataDecryptionKey`       | string  | *No*     | -       | Controls the decryption key used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                          |
|     `DataDecryptionIV`        | string  | *No*     | -       | Controls the decryption IV used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                           |
| `responseParameters`          | object  | *No*     | -       | -                                                                                                                                                                                                                                                |
|     `body`                    | object  | *No*     | -       | Response body.                                                                                                                                                                                                                                   |
|     `pageCount`               | integer | *No*     | -       | Number of pages in the PDF document.                                                                                                                                                                                                             |
|     `error`                   | boolean | *No*     | -       | Indicates whether an error occurred (`false` means success)                                                                                                                                                                                      |
|     `status`                  | string  | *No*     | -       | Status code of the request (200, 404, 500, etc.). For more information, see [Response Codes](/api-reference/response-codes).                                                                                                                     |
|     `name`                    | string  | *No*     | -       | Name of the output file                                                                                                                                                                                                                          |
|     `credits`                 | integer | *No*     | -       | Number of credits consumed by the request                                                                                                                                                                                                        |
|     `remainingCredits`        | integer | *No*     | -       | Number of credits remaining in the account                                                                                                                                                                                                       |
|     `duration`                | integer | *No*     | -       | Time taken for the operation in milliseconds                                                                                                                                                                                                     |

## `Example` Payload

<Note>To see the request size limits, please refer to the [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).</Note>

```json theme={null}
{
  "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/email-extractor/sample.eml",
  "inline": true,
  "async": false
}
```

## `Example` Response

<Note>To see the main response codes, please refer to the [Response Codes](/api-reference/response-codes) page.</Note>

```json theme={null}
{
  "body": {
    "from": "test@example.com",
    "subject": "Test email with attachments",
    "bodyHtml": null,
    "bodyText": "Test Email Message with 2 PDF files as attachments\r\n\r\n",
    "attachments": [
      {
        "filename": "DigitalOcean.pdf",
        "url": "https://pdf-temp-files.s3.amazonaws.com/2943e6bb80e646ec92e839292e95d542/DigitalOcean.pdf"
      },
      {
        "filename": "sample.pdf",
        "url": "https://pdf-temp-files.s3.amazonaws.com/e10e37fbb438432a83ece50ccdc719b3/sample.pdf"
      }
    ]
  },
  "pageCount": 2,
  "error": false,
  "status": 200,
  "name": "sample.json",
  "remainingCredits": 60085
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request POST 'https://api.pdf.co/v1/email/extract-attachments' \
    --header 'Content-Type: application/json' \
    --header 'x-api-key: *******************' \
    --data-raw '{
    "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/email-extractor/sample.eml",
    "inline": true,
    "async": false
    }'
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    var request = require('request');
    var options = {
      'method': 'POST',
      'url': 'https://api.pdf.co/v1/email/send',
      'headers': {
        'Content-Type': 'application/json',
        'x-api-key': 'ADD_YOUR_PDFco_API_KEY'
      },
      body: JSON.stringify({
        "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-info/sample.pdf",
        "from": "John Doe <john@example.com>",
        "to": "Partner <partner@example.com>",
        "subject": "Check attached sample pdf",
        "bodytext": "Please check the attached pdf",
        "bodyHtml": "Please check the attached pdf",
        "smtpserver": "smtp.gmail.com",
        "smtpport": "587",
        "smtpusername": "my@gmail.com",
        "smtppassword": "app specific password created as https://support.google.com/accounts/answer/185833",
        "async": false
      })

    };
    request(options, function (error, response) {
      if (error) throw new Error(error);
      console.log(response.body);
    });
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import requests
    import json

    url = "https://api.pdf.co/v1/email/send"

    payload = json.dumps({
      "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-info/sample.pdf",
      "from": "John Doe <john@example.com>",
      "to": "Partner <partner@example.com>",
      "subject": "Check attached sample pdf",
      "bodytext": "Please check the attached pdf",
      "bodyHtml": "Please check the attached pdf",
      "smtpserver": "smtp.gmail.com",
      "smtpport": "587",
      "smtpusername": "my@gmail.com",
      "smtppassword": "app specific password created as https://support.google.com/accounts/answer/185833",
      "async": False
    })
    headers = {
        'Content-Type': 'application/json',
        'x-api-key': 'ADD_YOUR_API_KEY'
    }

    response = requests.request("POST", url, headers=headers, data=payload)

    print(response.text)
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using Newtonsoft.Json;
    using Newtonsoft.Json.Linq;
    using System;
    using System.Collections.Generic;
    using System.Net;

    namespace PDFcoApiExample
    {
        class Program
      {
        // The authentication key (API Key).
        // Get your own by registering at https://app.pdf.co
        const String API_KEY = "***********************************";

        // Direct URL of source PDF file.
        const string SourceFileUrl = "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-info/sample.pdf";

        // Email Details

        const string From = "John Doe <john@example.com>";
        const string To = "Partner <partner@example.com>";
        const string Subject = "Check attached sample pdf";
        const string BodyText = "Please check the attached pdf";
        const string BodyHtml = "Please check the attached pdf";
        const string SmtpServer = "smtp.gmail.com";
        const string SmtpPort = "587";
        const string SmtpUserName = "my@gmail.com";
        const string SmtpPassword = "app specific password created as https://support.google.com/accounts/answer/185833";

        static void Main(string[] args)
        {
          // Create standard .NET web client instance
          WebClient webClient = new WebClient();

          // Set API Key
          webClient.Headers.Add("x-api-key", API_KEY);

          // URL for `Email Send` API call
          string url = "https://api.pdf.co/v1/email/send";

          // Prepare requests params as JSON
          Dictionary<string, object> parameters = new Dictionary<string, object>();
          parameters.Add("url", SourceFileUrl);

          parameters.Add("from", From);
          parameters.Add("to", To);
          parameters.Add("subject", Subject);
          parameters.Add("bodytext", BodyText);
          parameters.Add("bodyHtml", BodyHtml);
          parameters.Add("smtpserver", SmtpServer);
          parameters.Add("smtpport", SmtpPort);
          parameters.Add("smtpusername", SmtpUserName);
          parameters.Add("smtppassword", SmtpPassword);

          // Convert dictionary of params to JSON
          string jsonPayload = JsonConvert.SerializeObject(parameters);

          try
          {
            // Execute POST request with JSON payload
            string response = webClient.UploadString(url, jsonPayload);

            // Parse JSON response
            JObject json = JObject.Parse(response);

            if (json["error"].ToObject<bool>() == false)
            {
              Console.WriteLine("Email Sent Successfully!");
            }
            else
            {
              Console.WriteLine(json["message"].ToString());
            }
          }
          catch (WebException e)
          {
            Console.WriteLine(e.ToString());
          }

          webClient.Dispose();

          Console.WriteLine();
          Console.WriteLine("Press any key...");
          Console.ReadKey();
        }
      }
    }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    import java.io.*;
    import okhttp3.*;
    public class main {
        public static void main(String []args) throws IOException{
            OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
            MediaType mediaType = MediaType.parse("application/json");

              // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/    
            RequestBody body = new MultipartBody.Builder().setType(MultipartBody.FORM)
                .addFormDataPart("url", "https://pdfco-test-files.s3.us-west-2.amazonaws.com/email-extractor/sample.eml")
                .build();
            Request request = new Request.Builder()
                .url("https://api.pdf.co/v1/email/extract-attachments")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("x-api-key", "{{x-api-key}}")
                .build();
            Response response = client.newCall(request).execute();
            System.out.println(response.body().string());
        }
    }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <?php

        $curl = curl_init();

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api.pdf.co/v1/email/send',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{
            "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-info/sample.pdf",
            "from": "John Doe <john@example.com>",
            "to": "Partner <partner@example.com>",
            "subject": "Check attached sample pdf",
            "bodytext": "Please check the attached pdf",
            "bodyHtml": "Please check the attached pdf",
            "smtpserver": "smtp.gmail.com",
            "smtpport": "587",
            "smtpusername": "my@gmail.com",
            "smtppassword": "app specific password created as https://support.google.com/accounts/answer/185833",
            "async": false
        }',
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json',
                'x-api-key: ADD_YOUR_PDFco_KEY_HERE'
            ),
        ));

        $response = json_decode(curl_exec($curl));

        curl_close($curl);
        echo "<h2>Output:</h2><pre>", var_export($response, true), "</pre>";
      ?>
    ```
  </Tab>
</Tabs>
